unit Main;

{ Demo program for the TLZHCompressor component.
  Copyright Douglas P. Webb, 1995, All rights Reserved. }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, LZH_OP;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileExitItem: TMenuItem;
    SpeedBar: TPanel;
    SpeedButton1: TSpeedButton;
    Compress1: TMenuItem;
    Decompress1: TMenuItem;
    OpenDialog: TOpenDialog;
    LZHC: TLZHCompressor;
    Label1: TLabel;  { E&xit }
    procedure FileExit(Sender: TObject);
    procedure Compress1Click(Sender: TObject);
    procedure LZHCPressFinished(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Decompress1Click(Sender: TObject);
  private
    infile, outfile : File;

    procedure GetBytes(Sender:TObject; VAR DTA; NBytes:WORD; VAR Bytes_Got : WORD);
    procedure PutBytes(Sender:TObject; VAR DTA; NBytes:WORD; VAR Bytes_Put : WORD);

  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}



procedure TMainForm.GetBytes(Sender:TObject; VAR DTA; NBytes:WORD; VAR Bytes_Got : WORD);
  begin
  Screen.Cursor := crSizeWE + (SUCC(Screen.Cursor) - crSizeWE) MOD 4;
  Application.ProcessMessages;
  BlockRead(infile, DTA, NBytes, Bytes_Got);
  end;

procedure TmainForm.PutBytes(Sender:TObject; VAR DTA; NBytes:WORD; VAR Bytes_Put : WORD);
  begin
  BlockWrite(outfile, DTA, NBytes, Bytes_Put);
  end;


procedure TMainForm.FileExit(Sender: TObject);
  begin
  Close;
  end;

procedure TMainForm.Compress1Click(Sender: TObject);

  begin
  OpenDialog.Filter := 'All Files|*.*';
  if OpenDialog.Execute then
    begin
    AssignFile(InFile, OpenDialog.FileName);
    Reset(Infile,1);
    AssignFile(OutFile, ChangeFileExt(OpenDialog.FileName,'.LZD'));
    Rewrite(Outfile,1);
    Screen.Cursor := crSizeWE;
    Application.ProcessMessages;
    try
      Label1.Caption := 'Compressing...';
      LZHC.Compress;
    finally
      Screen.Cursor := crDefault;
      Application.ProcessMessages;
      CloseFile(infile);
      CloseFile(outfile);
    end;
    end;
  end;

procedure TMainForm.Decompress1Click(Sender: TObject);
  begin
  OpenDialog.Filter := 'LHA 1.x Style|*.LZD';
  if OpenDialog.Execute then
    begin
    AssignFile(InFile, OpenDialog.FileName);
    Reset(Infile,1);
    AssignFile(OutFile, ChangeFileExt(OpenDialog.FileName,'.$$$'));
    Rewrite(Outfile,1);
    Screen.Cursor := crSizeWE;
    Application.ProcessMessages;
    try
      Label1.Caption := 'Decompressing...';
      LZHC.DeCompress;
    finally
      Screen.Cursor := crDefault;
      Application.ProcessMessages;
      CloseFile(infile);
      CloseFile(outfile);
    end;
    end;

  end;


procedure TMainForm.LZHCPressFinished(Sender: TObject);
  begin
  Label1.Caption := 'Done!';
  end;

procedure TMainForm.FormCreate(Sender: TObject);
  begin
  { Assigning these at design time doesn't seem to work. }
  LZHC.OnGetBytes := GetBytes;
  LZHC.OnPutBytes := PutBytes;
  end;

end.
