unit Fngsrv;

{   Module:     FngSrv
    Author:     Stuart Seath
    Date:       Apr-95
    Copyright:  Lenham Computer Services Ltd 1995
    Description: Advanced Interface Finger server Example for IpSocket

    The Information and code provided hereunder (collectively referred to
    as "SOFTWARE") is provided as is without warranty of any kind, either
    express or implied, including but not limited to the implied warranties
    of merchanantability and fitness for a particular purpose. In no event
    shall Lenham Computer Services Ltd be liable for any damages whatsoever
    including direct, indirect, incidental, consequential, loss of business
    profits or special damages, even if Lenham Computer Services Ltd have
    been advised of the possibility of such damages.
}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, IpSocket, StdCtrls;

type
  TForm1 = class(TForm)
    IpSocket1: TIpSocket;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure IpSocket1SessionAccept(Socket: Word);
  private
    { Private declarations }
    LSocket: TSocket;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
    LSocket := IpSocket1.OpenSocket;
    IpSocket1.LocalPort := 'finger';
    IpSocket1.ListenOnSocket (LSocket,5);
end;

procedure TForm1.IpSocket1SessionAccept(Socket: Word);
var
    s1,s2,s3: string;
    data: TStringList;
    OSocket: TSocket;
begin
    OSocket := IpSocket1.AcceptConnection (Socket,s1,s2,s3);
    Memo1.Lines.Clear;
    Memo1.Lines.Add(S1);
    Memo1.Lines.Add(S2);
    Memo1.Lines.Add(S3);
    data := TStringList.create;
    data.add (IpSocket1.LocalHostName);
    data.add (IpSocket1.LocalAddress);
    IpSocket1.SendData (OSocket,data);
    data.free;
    IpSocket1.ShutSocket (OSocket);
end;

end.
